﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace XMLVerify {
    /// <summary>
    /// Interaction logic for FReadRoot.xaml
    /// </summary>
    public partial class FReadRoot : Window {
        private bool retcode = false;

        public bool Retcode {
            get { return retcode; }
        }

        public String root = "";
        public String firstItem = "";

        public FReadRoot(Window parent) {
            InitializeComponent();
            this.Owner = parent;  // Important, because CenterOwner            
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            tRoot.Focus();
        }

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            root = tRoot.Text.Trim();
            firstItem = tItem.Text.Trim();
            if (!Basis.CheckEntity(root)) {
                Basis.ErrorMsg("Bitte ein gültiges Root-Element eingeben.\r\nEr muss mit einem Buchstaben anfangen\r\nund dann Buchstaben, Zahlen und der Unterstrich erlaubt.", "Hinweis");
                return;
            }
            if (!Basis.CheckEntity(firstItem)) {
                Basis.ErrorMsg("Bitte ein gültiges 1. Element eingeben.\r\nEr muss mit einem Buchstaben anfangen\r\nund dann Buchstaben, Zahlen und der Unterstrich erlaubt.", "Hinweis");
                return;
            }
            retcode = true;
            Close();
        }

        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }

        private void Window_KeyDown(object sender, KeyEventArgs e) {
            if (Keyboard.IsKeyDown(Key.Return)) {
                bnOk_Click(sender, e);
            }
            if (Keyboard.IsKeyDown(Key.Escape)) {
                bnEsc_Click(sender, e);
            }
        }

    }
}