﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Xml;
using System.IO;

// neu in WPF
using System.Windows.Controls;
using System.Windows;
using System.Windows.Input;


namespace XMLVerify
{
    public class MyTabControl : TabControl, IView
    {

        System.Windows.Media.Brush[] colors=null;

        private TreeView tree=null;
        private MyFileList filelist=null;
        TabItem tabPage1;
        TabItem tabPage2;
        int depth;


        public void setFontsize(int size)
        {
            tree.FontSize = size;
            filelist.setFontsize(size);
            this.FontSize = size;
            tabPage1.FontSize = size;
            tabPage2.FontSize = size;
        }


        public MyTabControl()
        {
            CModell modell = CModell.getInstance();
            modell.addObserver(this);

            this.TabStripPlacement = Dock.Bottom;
            // this.Background = System.Windows.Media.Brushes.Yellow;
            
            tree = new TreeView();
            


            filelist = new MyFileList();

            tabPage1 = new TabItem();
            tabPage2 = new TabItem();
            tabPage1.Header = "File-List";
            tabPage2.Header = "XML-Tree";

            tabPage1.Content = filelist;
            tabPage2.Content = tree;

            this.Items.Add(tabPage1);
            this.Items.Add(tabPage2);
           
        }

        
        private TreeViewItem addNode(TreeViewItem parent, String element)
        {
            TreeViewItem node;
            node = new TreeViewItem();
            node.Header = element;
            
            // node.IsChecked = true;
            node.Tag = element;
            parent.Items.Add(node);
            return node;
        }

        private void insertNodes(TreeViewItem parent, XmlNode item)
        {
            TreeViewItem node;
            depth++;
            foreach (XmlNode subitem in item.ChildNodes)
            {
                if (subitem.HasChildNodes)
                {
                    node = addNode(parent, subitem.LocalName); //item.InnerXml); //item.InnerText);
                    if (depth < colors.Length)
                    {
                        node.Foreground = colors[depth];
                    }
                }
                else
                {
                    node = addNode(parent, subitem.InnerText); //item.InnerXml); //item.InnerText);
                    node.Foreground = System.Windows.Media.Brushes.Yellow;
                    node.Background = System.Windows.Media.Brushes.Blue;
                }
                insertNodes(node, subitem);

            }
            depth--;
        }
        
        public void insertNodes()  {
            
            TreeViewItem root;
            tree.Items.Clear();

            CModell modell = CModell.getInstance();

            String fileXML = modell.FilenameXML;
            String fileXSD_DTD = modell.FilenameXSD;

            if (File.Exists(fileXML) && File.Exists(fileXSD_DTD))
            {
                if (colors == null)
                {
                    colors = new System.Windows.Media.Brush[20];
                    colors[0] = System.Windows.Media.Brushes.DarkOliveGreen;
                    colors[1] = System.Windows.Media.Brushes.DarkTurquoise;
                    colors[2] = System.Windows.Media.Brushes.DarkGoldenrod;
                    colors[3] = System.Windows.Media.Brushes.BlueViolet;
                    colors[4] = System.Windows.Media.Brushes.OldLace;
                    colors[5] = System.Windows.Media.Brushes.Peru;
                    colors[6] = System.Windows.Media.Brushes.RosyBrown;
                    colors[7] = System.Windows.Media.Brushes.Tan;

                    colors[8] = System.Windows.Media.Brushes.Yellow;
                    colors[9] = System.Windows.Media.Brushes.LightSeaGreen;
                    colors[10] = System.Windows.Media.Brushes.LightSkyBlue;
                    colors[11] = System.Windows.Media.Brushes.Red;
                    colors[12] = System.Windows.Media.Brushes.DarkBlue;
                    colors[13] = System.Windows.Media.Brushes.Green;
                    colors[14] = System.Windows.Media.Brushes.Linen;
                    colors[15] = System.Windows.Media.Brushes.MediumTurquoise;
                    colors[16] = System.Windows.Media.Brushes.Indigo;
                    colors[17] = System.Windows.Media.Brushes.Turquoise;
                    colors[18] = System.Windows.Media.Brushes.Wheat;
                    colors[19] = System.Windows.Media.Brushes.Yellow;
                }
                if (fileXSD_DTD.ToLower().EndsWith("xml")) {
                    depth = 0;
                    // tree.BeginUpdate(); // Unterdrücken des Neuzeichnens
                    XmlDocument doc = new XmlDocument();
                    doc.Load(fileXML);

                    //foreach (XmlNode item in doc)
                    // es gibt zwei root´s   a) xml   b) root
                    root = new TreeViewItem();
                    root.Header = doc.LastChild.LocalName;
                    tree.Items.Add(root);
                    root.Foreground = System.Windows.Media.Brushes.CornflowerBlue;
                    root.Background = System.Windows.Media.Brushes.LightYellow;

                    insertNodes(root, doc.LastChild);


                    root.ExpandSubtree();
                }
                // tree.EndUpdate();  // Neu Zeichnen
            }
             
        }  // insertNodes
        

        public void update()
        {
            insertNodes();
        }

    }
}
